# Center finder.  Select an object and the script gives you
# the actual center.
# By Ockham, 3/07
import poser
import math
import string
scene = poser.Scene()
A=scene.CurrentActor()
G=None
try:
    G=A.Geometry()
except:
    pass
if not G: raise "Selected object %s has no mesh." % A.Name()

Vcount=G.NumVertices()
scene.DrawAll()
MinX= 10000.0
MinY= 10000.0
MinZ= 10000.0
MaxX=-10000.0
MaxY=-10000.0
MaxZ=-10000.0
for V in range(Vcount):
    WV=G.WorldVertex(V)
    X=WV.X()
    Y=WV.Y()
    Z=WV.Z()
    if X>MaxX:MaxX=X
    elif X<MinX:MinX=X
    if Y>MaxY:MaxY=Y
    elif Y<MinY:MinY=Y
    if Z>MaxZ:MaxZ=Z
    elif Z<MinZ:MinZ=Z

X=(MaxX+MinX)/2.0
Y=(MaxY+MinY)/2.0
Z=(MaxZ+MinZ)/2.0
# This XYZ is the real center.
print "Real center %.3f %.3f %.3f" % (X,Y,Z)
# Move the Trans so that the thing will be on the scene's center.
A.ParameterByCode(poser.kParmCodeXTRAN).SetValue(-X)
A.ParameterByCode(poser.kParmCodeYTRAN).SetValue(-Y)
A.ParameterByCode(poser.kParmCodeZTRAN).SetValue(-Z)
A.SetOrigin(0,0,0)
print "The prop has been re-centered. You can now resave."
